=== debian/control ===
Source: vart
Section: libs
Priority: optional
Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
Uploaders: Punit Agrawal <punit@debian.org>,
           Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: cmake, debhelper-compat (= 13),
	dh-exec,
	libboost-filesystem-dev,
	libjson-c-dev,
	libprotobuf-dev,
	libssl-dev,
	libtarget-factory-dev,
	libunilog-dev,
	libxir-dev,
	libxrt-dev,
	uuid-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/Xilinx/Vitis-AI
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/vitis-ai/vart.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/vitis-ai/vart

Package: libvart2
Architecture: amd64 arm64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Vitis AI RuntTime library
 Vitis AI RunTime is an application level runtime interface for DPU
 IPs based on XRT. It use XIR subgraph as input, and runs it on
 different targets. There are also emulators implemented with same
 interface to make debuging eaiser.
 .
 This package provides the runtime environment for Vitis AI RuntTime library.

Package: libvart-dev
Architecture: amd64 arm64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libvart2 (= ${binary:Version})
Description: Vitis AI RuntTime library (development)
 Vitis AI RunTime is an application level runtime interface for DPU
 IPs based on XRT. It use XIR subgraph as input, and runs it on
 different targets. There are also emulators implemented with same
 interface to make debuging eaiser.
 .
 This package provides the development environment for Vitis AI RuntTime
 library.

Package: vart-bin
Architecture: amd64 arm64
Section: utils
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Vitis AI RuntTime library (utilities)
 Vitis AI RunTime is an application level runtime interface for DPU
 IPs based on XRT. It use XIR subgraph as input, and runs it on
 different targets. There are also emulators implemented with same
 interface to make debuging eaiser.
 .
 This package contains the utility files for Vitis AI RuntTime library.
