=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Debug \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	-DENABLE_DPU_RUNNER=ON \
	-DENABLE_XRNN_RUNNER=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)
